"""
    Pinterest REST API

    Pinterest's REST API  # noqa: E501

    The version of the OpenAPI document: 5.6.0
    Contact: pinterest-api@pinterest.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from pinterest.generated.client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from pinterest.generated.client.exceptions import ApiAttributeError


def lazy_import():
    from pinterest.generated.client.model.campaign_create_common import CampaignCreateCommon
    from pinterest.generated.client.model.campaign_create_response_data_all_of import CampaignCreateResponseDataAllOf
    from pinterest.generated.client.model.campaign_response import CampaignResponse
    from pinterest.generated.client.model.entity_status import EntityStatus
    from pinterest.generated.client.model.objective_type import ObjectiveType
    from pinterest.generated.client.model.tracking_urls import TrackingUrls
    globals()['CampaignCreateCommon'] = CampaignCreateCommon
    globals()['CampaignCreateResponseDataAllOf'] = CampaignCreateResponseDataAllOf
    globals()['CampaignResponse'] = CampaignResponse
    globals()['EntityStatus'] = EntityStatus
    globals()['ObjectiveType'] = ObjectiveType
    globals()['TrackingUrls'] = TrackingUrls


class CampaignCreateResponseData(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('ad_account_id',): {
            'regex': {
                'pattern': r'^\d+$',  # noqa: E501
            },
        },
        ('order_line_id',): {
            'regex': {
                'pattern': r'^\d+$',  # noqa: E501
            },
        },
        ('id',): {
            'regex': {
                'pattern': r'^\d+$',  # noqa: E501
            },
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'ad_account_id': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'lifetime_spend_cap': (int, none_type,),  # noqa: E501
            'daily_spend_cap': (int, none_type,),  # noqa: E501
            'order_line_id': (str, none_type,),  # noqa: E501
            'tracking_urls': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}, none_type,),  # noqa: E501
            'start_time': (int, none_type,),  # noqa: E501
            'end_time': (int, none_type,),  # noqa: E501
            'is_campaign_budget_optimization': (bool, none_type,),  # noqa: E501
            'is_flexible_daily_budgets': (bool, none_type,),  # noqa: E501
            'default_ad_group_budget_in_micro_currency': (int, none_type,),  # noqa: E501
            'is_automated_campaign': (bool,),  # noqa: E501
            'id': (str,),  # noqa: E501
            'objective_type': (ObjectiveType,),  # noqa: E501
            'created_time': (int,),  # noqa: E501
            'updated_time': (int,),  # noqa: E501
            'type': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'ad_account_id': 'ad_account_id',  # noqa: E501
        'name': 'name',  # noqa: E501
        'status': 'status',  # noqa: E501
        'lifetime_spend_cap': 'lifetime_spend_cap',  # noqa: E501
        'daily_spend_cap': 'daily_spend_cap',  # noqa: E501
        'order_line_id': 'order_line_id',  # noqa: E501
        'tracking_urls': 'tracking_urls',  # noqa: E501
        'start_time': 'start_time',  # noqa: E501
        'end_time': 'end_time',  # noqa: E501
        'is_campaign_budget_optimization': 'is_campaign_budget_optimization',  # noqa: E501
        'is_flexible_daily_budgets': 'is_flexible_daily_budgets',  # noqa: E501
        'default_ad_group_budget_in_micro_currency': 'default_ad_group_budget_in_micro_currency',  # noqa: E501
        'is_automated_campaign': 'is_automated_campaign',  # noqa: E501
        'id': 'id',  # noqa: E501
        'objective_type': 'objective_type',  # noqa: E501
        'created_time': 'created_time',  # noqa: E501
        'updated_time': 'updated_time',  # noqa: E501
        'type': 'type',  # noqa: E501
    }

    read_only_vars = {
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """CampaignCreateResponseData - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            ad_account_id (str): Campaign's Advertiser ID.. [optional]  # noqa: E501
            name (str): Campaign name.. [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            lifetime_spend_cap (int, none_type): Campaign total spending cap.. [optional]  # noqa: E501
            daily_spend_cap (int, none_type): Campaign daily spending cap.. [optional]  # noqa: E501
            order_line_id (str, none_type): Order line ID that appears on the invoice.. [optional]  # noqa: E501
            tracking_urls ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}, none_type): [optional]  # noqa: E501
            start_time (int, none_type): Campaign start time. Unix timestamp in seconds. Only used for Campaign Budget Optimization (CBO) campaigns.. [optional]  # noqa: E501
            end_time (int, none_type): Campaign end time. Unix timestamp in seconds. Only used for Campaign Budget Optimization (CBO) campaigns.. [optional]  # noqa: E501
            is_campaign_budget_optimization (bool, none_type): Determines if a campaign automatically generate ad-group level budgets given a campaign budget to maximize campaign outcome. When transitioning from non-cbo to cbo, all previous child ad group budget will be cleared.. [optional]  # noqa: E501
            is_flexible_daily_budgets (bool, none_type): Determines if a campaign has flexible daily budgets setup.. [optional]  # noqa: E501
            default_ad_group_budget_in_micro_currency (int, none_type): When transitioning from campaign budget optimization to non-campaign budget optimization, the default_ad_group_budget_in_micro_currency will propagate to each child ad groups daily budget. Unit is micro currency of the associated advertiser account.. [optional]  # noqa: E501
            is_automated_campaign (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
            id (str): Campaign ID.. [optional]  # noqa: E501
            objective_type (ObjectiveType): [optional]  # noqa: E501
            created_time (int): Campaign creation time. Unix timestamp in seconds.. [optional]  # noqa: E501
            updated_time (int): UTC timestamp. Last update time.. [optional]  # noqa: E501
            type (str): Always \"campaign\".. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """CampaignCreateResponseData - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            ad_account_id (str): Campaign's Advertiser ID.. [optional]  # noqa: E501
            name (str): Campaign name.. [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            lifetime_spend_cap (int, none_type): Campaign total spending cap.. [optional]  # noqa: E501
            daily_spend_cap (int, none_type): Campaign daily spending cap.. [optional]  # noqa: E501
            order_line_id (str, none_type): Order line ID that appears on the invoice.. [optional]  # noqa: E501
            tracking_urls ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}, none_type): [optional]  # noqa: E501
            start_time (int, none_type): Campaign start time. Unix timestamp in seconds. Only used for Campaign Budget Optimization (CBO) campaigns.. [optional]  # noqa: E501
            end_time (int, none_type): Campaign end time. Unix timestamp in seconds. Only used for Campaign Budget Optimization (CBO) campaigns.. [optional]  # noqa: E501
            is_campaign_budget_optimization (bool, none_type): Determines if a campaign automatically generate ad-group level budgets given a campaign budget to maximize campaign outcome. When transitioning from non-cbo to cbo, all previous child ad group budget will be cleared.. [optional]  # noqa: E501
            is_flexible_daily_budgets (bool, none_type): Determines if a campaign has flexible daily budgets setup.. [optional]  # noqa: E501
            default_ad_group_budget_in_micro_currency (int, none_type): When transitioning from campaign budget optimization to non-campaign budget optimization, the default_ad_group_budget_in_micro_currency will propagate to each child ad groups daily budget. Unit is micro currency of the associated advertiser account.. [optional]  # noqa: E501
            is_automated_campaign (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
            id (str): Campaign ID.. [optional]  # noqa: E501
            objective_type (ObjectiveType): [optional]  # noqa: E501
            created_time (int): Campaign creation time. Unix timestamp in seconds.. [optional]  # noqa: E501
            updated_time (int): UTC timestamp. Last update time.. [optional]  # noqa: E501
            type (str): Always \"campaign\".. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [

          ],
          'oneOf': [
          ],
        }
